Page MenuHomePhabricator

[GOAL] Deploy the new Vue.js search experience
Closed, ResolvedPublic

Description

NOTE: this epic is a draft and should be considered work-in-progress until resolution or this notice is removed. Please coordinate your contributions prior to making them.

This Epic captures all tasks for building and deploying a vastly improved, modern search experience using tooling that's just as up-to-date. The work is part of Vector's Desktop Improvements Project and the Frontend Architecture Working Group's initial Vue.js iterations pilot project by the Wikipedia Web team and collaborators. We hope that the new search functionality will meet or exceed the expectations of our users and that the new development workflows will be a milestone for improving developer productivity and happiness.

search-2.png (770×1 px, 313 KB)

At a high level, the project objectives are:

The project is currently slated for completion by September 30th, 2020. This date may change as the initial MediaWiki integration iterations were always known to be one of the trickiest parts of framework adoption. (For additional context, simply picking a framework took more than 10 people more than six months and the Web team is tiny.) Lastly, the ongoing pandemic continues to put schedules in flux.

The work is organized such that almost all tasks include the phrase "Vue.js search" in their titles. Most tooling tasks are tagged #vue.js-search (many could additionally be tagged Technical-Debt). Prioritized tasks are also tagged Desktop Improvements (Vector 2022). Direct subtasks of this epic (second tier epics) are not arranged in proper dependency order to avoid the dependency tree becoming uncomfortably wide. The intended order of execution is something like: scaffolding, build, deploy, iterate, and postmortem.

References

[0] In the Front End Standards Group's April 8th convening (when this epic was initially shared), TechCom representatives stated that component sharing is a hard requirement for the initial groundwork furnished by the new Vue.js search project iterations. Reasons given were numerous but focused largely on past framework mistakes that are considered beyond repair, massive deviations such as MobileFrontend whose technical debt is usurious, and the current state of component proliferation across WMDE, NearbyPages, ContentTranslation, and MachineVision extensions which may have already built some of the Vue.js components needed. However, there were no objections to where components initially lived.

Related Objects

StatusSubtypeAssignedTask
OpenNone
Resolvedovasileva
ResolvedJdlrobson
ResolvedNone
Resolvedkostajh
ResolvedSpikenray
ResolvedSpikeVolker_E
ResolvedJdrewniak
ResolvedJdrewniak
ResolvedSpikeNone
ResolvedSpikeNone
ResolvedSpikeJdlrobson
ResolvedSpikeNone
ResolvedSpike holger.knust
ResolvedSpikeJdlrobson
DuplicateNone
Resolvednray
ResolvedSpikeNiedzielski
ResolvedSpikeNiedzielski
ResolvedJdlrobson
ResolvedJdlrobson
ResolvedSpikeVolker_E
ResolvedSpikeVolker_E
ResolvedJdrewniak
ResolvedJdlrobson
Resolved nnikkhoui
ResolvedNone
Resolved nnikkhoui
ResolvedJdlrobson
Resolved nnikkhoui
ResolvedJdlrobson
ResolvedJdlrobson
ResolvedVolker_E
Resolvedphuedx
Resolved eprodromou
ResolvedEvanProdromou
ResolvedPeter.ovchyn
ResolvedPeter.ovchyn
ResolvedPeter.ovchyn
Resolved eprodromou
ResolvedPeter.ovchyn
Resolveddaniel
Resolveddaniel
Resolveddaniel
Resolved holger.knust
Resolved holger.knust
Resolved holger.knust
OpenNone
OpenNone
OpenNone
ResolvedSpikeovasileva
Resolvedphuedx
ResolvedJdrewniak
Resolvedalexhollender_WMF
Resolvedovasileva
ResolvedJdlrobson
ResolvedJdrewniak
ResolvedJdrewniak
ResolvedNiedzielski
ResolvedMNeisler
Resolvedovasileva
Resolvedphuedx
Resolvedovasileva
Resolvedovasileva
Resolvednray
OpenNone
Resolvedovasileva
ResolvedVolker_E
OpenNone
ResolvedStevenSun
DeclinedNone
Resolvedovasileva
Resolvedovasileva
Resolvedovasileva
Resolvedphuedx
Resolvedovasileva
ResolvedMNeisler
Resolvedovasileva
Resolvedovasileva
Resolvedovasileva
Resolvedovasileva
DuplicateNone
Resolvedalexhollender_WMF
ResolvedMNeisler
ResolvedJdlrobson
DuplicateNone
Resolvedovasileva
Resolvedovasileva
Declinedovasileva
Resolvedovasileva
Resolvedovasileva
ResolvedEdtadros
DeclinedNone
DeclinedNone
ResolvedJdrewniak
ResolvedJdrewniak
Resolved nnikkhoui
Resolved nnikkhoui
ResolvedJdlrobson
Duplicateovasileva
ResolvedMNeisler
ResolvedVolker_E
Resolvedphuedx
Resolvedovasileva
Resolvedovasileva
Resolvedsbassett
Resolved jlinehan
OpenNone
ResolvedNone
Resolved jlinehan
Resolved jlinehan
ResolvedOttomata
ResolvedOttomata
ResolvedSpikeJdlrobson
Resolved jlinehan
OpenNone
Resolved jlinehan
Resolved jlinehan
Resolved jlinehan
Resolved jlinehan
ResolvedJdlrobson
Resolved jlinehan
Resolved jlinehan
Opendr0ptp4kt
Resolvedcolewhite
DeclinedNone
ResolvedNone
Resolved jlinehan
OpenNone
OpenBUG REPORTNone
OpenNone
Openovasileva
Resolvedphuedx
Resolvedalexhollender_WMF
Resolvedovasileva
DuplicateNone
Resolvedalexhollender_WMF
ResolvedMNeisler

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
Niedzielski renamed this task from [Epic] Deploy the new search experience to [Epic] Build and deploy the new search experience.Apr 3 2020, 1:52 AM
Niedzielski updated the task description. (Show Details)
ovasileva renamed this task from [Epic] Build and deploy the new search experience to [EPIC] Build and deploy the new search experience.Apr 3 2020, 8:26 AM
Niedzielski renamed this task from [EPIC] Build and deploy the new search experience to [EPIC] Build and deploy the new Vue.js search experience.Apr 5 2020, 4:19 PM

Related and prior art:

  • Wikipedia portal search:

Screenshot 2020-04-08 at 19.19.09.png (1×1 px, 478 KB)

  • VisualEditor link insert:

Screenshot 2020-04-08 at 19.20.03.png (1×1 px, 285 KB)

  • Minerva search:

Screenshot 2020-04-08 at 19.20.54.png (871×1 px, 264 KB)

ovasileva renamed this task from [EPIC] Build and deploy the new Vue.js search experience to [GOAL] Build and deploy the new Vue.js search experience.May 20 2020, 9:55 AM
ovasileva moved this task from Incoming to Q4 2020 on the Desktop Improvements (Vector 2022) board.
ovasileva edited projects, added Goal; removed Epic.

I just wanted to say as a Wikipedian for 15 years, every time I see the design in the top of the ticket, my heart melts. Great work. Keep it up <3

ovasileva renamed this task from [GOAL] Build and deploy the new Vue.js search experience to [GOAL] Deploy the new Vue.js search experience.Aug 31 2020, 12:39 PM